<template>
  <v-container>
    <v-form v-model="valid" @submit.prevent="onSubmit">
      <v-row>
        <v-col cols="12">
          <p class="text-center text-uppercase pt-4">
            {{ $t('join') }}
          </p>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" md="6">
          <v-text-field
            id="first-name"
            v-model="first_name"
            :label="$t('name')"
            :rules="rules"
            prepend-icon="mdi-account"
            required
          ></v-text-field>
        </v-col>
        <v-col cols="12" md="6">
          <v-text-field
            id="last-name"
            v-model="last_name"
            :label="$t('lastname')"
            :rules="rules"
            required
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12">
          <Wallets
            @change="setPublicAddress($event)"
            @handleDialog="selfOpen = $event"
          />
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12">
          <v-text-field
            id="email"
            v-model="email"
            :label="$t('email')"
            :rules="emailRules"
            prepend-icon="mdi-email"
            required
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12">
          <v-text-field
            id="password"
            v-model="password"
            type="password"
            :label="$t('password')"
            :rules="rules"
            prepend-icon="mdi-lock"
            required
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row justify="center" class="my-5">
        <div :id="captcha" class="recaptcha"></div>
      </v-row>
      <v-row>
        <v-col cols="12">
          <v-btn
            id="save-user"
            :disabled="!reCAPTCHARegisterEMAIL || !valid"
            block
            type="submit"
          >
            {{ $t('send') }}
          </v-btn>
        </v-col>
      </v-row>
    </v-form>
    <v-snackbar
      v-model="snackbar.show"
      :top="true"
      :right="true"
      :timeout="snackbar.timeout"
      :color="snackbar.color"
      :multi-line="snackbar.mode === 'multi-line'"
      :vertical="snackbar.mode === 'vertical'"
    >
      {{ snackbar.text }}
      <v-btn
        icon
        class="float-right"
        justify="center"
        align="center"
        @click.native="snackbar.show = false"
      >
        <v-icon>mdi-close</v-icon>
      </v-btn>
    </v-snackbar>
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue'
import Wallets from '@/components/Register/Wallets.vue'
import { setUserDoc, getUserByPublicAddress } from '~/services/User'
import { signUp } from '~/services/Firebase'

declare global {
  interface Window {
    recaptchaVerifierRegisterEmail: any
    recaptchaWidgetRegisterId: any
  }
}

export default Vue.extend({
  name: 'EmailRegister',
  components: {
    Wallets,
  },
  props: {
    captcha: {
      type: String,
      default: 'recaptcha-register-email',
    },
  },
  data() {
    return {
      valid: false,
      reCAPTCHARegisterEMAIL: false,
      first_name: '',
      last_name: '',
      email: '',
      password: '',
      selfOpen: true,
      rules: [(v: any) => !!v || 'Campo requerido'],
      emailRules: [
        (v: string) => !!v || 'El campo es requerido',
        (v: string) =>
          !v ||
          /^[-\w.%+]{1,64}@(?:[A-Z0-9-]{1,63}\.){1,125}[A-Z]{2,63}$/i.test(v) ||
          'Ingresa un email válido',
      ],
      snackbar: {
        show: false,
        color: '',
        mode: '',
        timeout: 6000,
        text: '',
        right: '',
        top: '',
      },
      public_address: '',
      loading: false,
    }
  },
  watch: {
    selfOpen(val) {
      this.$emit('handleDialogRegister', val)
    },
  },
  mounted() {
    const self = this
    window.recaptchaVerifierRegisterEmail = new self.$fireModule.auth.RecaptchaVerifier(
      this.captcha,
      {
        callback() {
          // eslint-disable-next-line @typescript-eslint/no-unused-vars
          return new Promise<string | void>((resolve, reject) => {
            self.reCAPTCHARegisterEMAIL = true
            resolve()
          })
        },
        'expired-callback': () => {
          // eslint-disable-next-line @typescript-eslint/no-unused-vars
          return new Promise<string | void>((resolve, reject) => {
            self.reCAPTCHARegisterEMAIL = false
          })
        },
        size: this.$vuetify.breakpoint.smAndDown ? 'compact' : 'normal',
      }
    )
    window.recaptchaVerifierRegisterEmail
      .render()
      .then(function (widgetId: any) {
        window.recaptchaWidgetRegisterId = widgetId
      })
  },
  methods: {
    setPublicAddress(address: string): void {
      this.public_address = address
    },
    async onSubmit(): Promise<void> {
      try {
        this.loading = true
        // Validate if public address exist
        const exist = await getUserByPublicAddress(this.$fire, {
          publicAddress: this.public_address,
        })
        if (exist.docs.length <= 0) {
          // Create user Auth
          const { user } = await signUp(this.$fire, {
            email: this.email,
            password: this.password,
          })
          // Create user collection
          await setUserDoc(this.$fire, user.uid, {
            email: this.email,
            first_name: this.first_name,
            last_name: this.last_name,
            public_address: this.public_address,
            activated: true,
          })
          window.recaptchaVerifierRegisterEmail.clear()
          this.loading = false
          this.$emit('change', false)
        } else {
          this.loading = false
          this.snackbar.show = true
          this.snackbar.text =
            'La llave pública ya está en uso por otra cuenta.'
          this.snackbar.color = 'error'
        }
      } catch (error) {
        this.loading = false
        this.snackbar.show = true
        this.snackbar.text =
          error.message ||
          'La dirección de correo electrónico ya está en uso por otra cuenta.'
        this.snackbar.color = 'error'
      }
    },
  },
})
</script>
